## tree 2.0.2

=== Makefile ===
# $Copyright: $
# Copyright (c) 1996 - 2022 by Steve Baker
# All Rights reserved
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

PREFIX=/usr/local

CC=gcc
INSTALL=install

VERSION=2.0.2
TREE_DEST=tree
DESTDIR=${PREFIX}/bin
MAN=tree.1
# Probably needs to be ${PREFIX}/share/man for most systems now
MANDIR=${PREFIX}/man
OBJS=tree.o list.o hash.o color.o file.o filter.o info.o unix.o xml.o json.o html.o strverscmp.o

# Uncomment options below for your particular OS:

# Linux defaults:
#CFLAGS=-ggdb -pedantic -Wall -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
CFLAGS=-O3 -pedantic -Wall -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
LDFLAGS=-s

# Uncomment for FreeBSD:
#CC=cc
#CFLAGS=-O2 -Wall -fomit-frame-pointer
#LDFLAGS=-s

# Uncomment for OpenBSD:
#TREE_DEST=colortree
#MAN=colortree.1
#CFLAGS=-O2 -Wall -fomit-frame-pointer
#LDFLAGS=-s

# Uncomment for Solaris:
#CC=cc
#CFLAGS=-xO0 -v
#LDFLAGS=
#MANDIR=${prefix}/share/man

# Uncomment for Cygwin:
#CFLAGS=-O2 -Wall -fomit-frame-pointer
#LDFLAGS=-s
#TREE_DEST=tree.exe

# Uncomment for OS X:
# It is not allowed to install to /usr/bin on OS X any longer (SIP):
#CC=cc
#CFLAGS=-O2 -Wall -fomit-frame-pointer -no-cpp-precomp
#LDFLAGS=
#MANDIR=${PREFIX}/share/man

# Uncomment for HP/UX:
#prefix=/opt
#CC=cc
# manpage of mbsrtowcs() requires C99 and the two defines
#CFLAGS=+w -D_XOPEN_SOURCE=500 -D_POSIX_C_SOURCE=200112 -AC99
#LDFLAGS=
#MANDIR=${PREFIX}/share/man

# Uncomment for OS/2:
#CFLAGS=-02 -Wall -fomit-frame-pointer -Zomf -Zsmall-conv
#LDFLAGS=-s -Zomf -Zsmall-conv

# Uncomment for HP NonStop:
#prefix = /opt
#CC=c89
#CFLAGS=-Wextensions -WIEEE_float -g -Wnowarn=1506 -D_XOPEN_SOURCE_EXTENDED=1 \
#	 -Wallow_cplusplus_comments
#LDFLAGS=

# AIX
#CC=cc_r -q64
#LD=ld -d64
#LDFLAGS=-lc

#------------------------------------------------------------

all:	tree

tree:	$(OBJS)
	$(CC) $(LDFLAGS) -o $(TREE_DEST) $(OBJS)

$(OBJS): %.o:	%.c tree.h
	$(CC) $(CFLAGS) -c -o $@ $<

clean:
	rm -f $(TREE_DEST) *.o *~

install: tree
	$(INSTALL) -d $(DESTDIR)
	$(INSTALL) -d $(MANDIR)/man1
	$(INSTALL) $(TREE_DEST) $(DESTDIR)/$(TREE_DEST); \
	$(INSTALL) -m 644 doc/$(MAN) $(MANDIR)/man1/$(MAN)

distclean:
	rm -f *.o *~

dist:	distclean
	tar zcf ../tree-$(VERSION).tgz -C .. `cat .tarball`

=== debian/changelog ===
tree (2.0.2-1ubuntu0.1) jammy; urgency=medium

  * Fix XML/JSON output on empty directories (LP: #2113790)
    - d/p/0001-tree-list-call-printinfo-on-error-cases-too.patch:
      call printinfo on error cases too, thanks to Simon Chopin

 -- Nadzeya Hutsko <nadzeya.hutsko@canonical.com>  Tue, 21 Oct 2025 10:27:43 +0200

tree (2.0.2-1) unstable; urgency=medium

  * [36b56c4] New upstream version 2.0.2

 -- Florian Ernst <florian@debian.org>  Thu, 17 Feb 2022 07:55:43 +0100

tree (2.0.1-2) unstable; urgency=medium

  * [98eb8c4] also install French manpage added in upstream's 2.0.0

 -- Florian Ernst <florian@debian.org>  Sat, 08 Jan 2022 10:26:06 +0100

tree (2.0.1-1) unstable; urgency=medium

  * [990450f] New upstream version 2.0.0
    - Properly sort --fromfile input (Chentao Credungtao via Debian)
      (Closes: #942020)
    - Make tree colorization use reset (rs code in dir_colors,) not normal
      color when resetting attributes (Filips Romāns via Debian)
      (Closes: #962581)
  * [0474490] New upstream version 2.0.1
  * [d190828] refresh patches
  * [ec7cb69] debian/patches/PATH_MAX: dropped, superseded by upstream's 2.0.0
  * [561d519] debian/rules: update to match upstream's Makefile
  * [797e636] Bump debhelper from deprecated 9 to debhelper-compat (= 13) in B-D
  * [a60db11] debian/watch: upgrade to recommended version
  * [f6cee15] debian/copyright: update year
  * [af67813] packaging now conforming with current Standards-Version 4.6.0.1

 -- Florian Ernst <florian@debian.org>  Fri, 07 Jan 2022 16:58:29 +0100

=== debian/control ===
Source: tree
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Florian Ernst <florian@debian.org>
Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.16.1~)
Standards-Version: 4.6.0.1
Homepage: http://mama.indstate.edu/users/ice/tree/
Vcs-Git: https://salsa.debian.org/debian/tree-packaging.git
Vcs-Browser: https://salsa.debian.org/debian/tree-packaging

Package: tree
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: displays an indented directory tree, in color
 Tree is a recursive directory listing command that produces a depth indented
 listing of files, which is colorized ala dircolors if the LS_COLORS environment
 variable is set and output is to tty.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

PREFIX = $(CURDIR)/debian/tree/usr
MANDIR = $(PREFIX)/share/man
CFLAGS += -Wall -DLINUX -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64

override_dh_auto_build:
	dh_auto_build -- CFLAGS="$(CFLAGS) $(CPPFLAGS)" LDFLAGS="$(LDFLAGS)"

override_dh_auto_install:
	$(MAKE) install PREFIX="$(PREFIX)" MANDIR="$(MANDIR)"

override_dh_auto_clean:
	$(MAKE) clean

%:
	dh $@

## tree 2.0.3

=== Makefile ===
--- 
+++ 
@@ -21,7 +21,7 @@
 CC=gcc
 INSTALL=install
 
-VERSION=2.0.2
+VERSION=2.0.3
 TREE_DEST=tree
 DESTDIR=${PREFIX}/bin
 MAN=tree.1
@@ -32,62 +32,62 @@
 # Uncomment options below for your particular OS:
 
 # Linux defaults:
-#CFLAGS=-ggdb -pedantic -Wall -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
-CFLAGS=-O3 -pedantic -Wall -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
-LDFLAGS=-s
+CFLAGS=-ggdb -pedantic -Wall -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
+#CFLAGS+=-O3 -pedantic -Wall -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
+#LDFLAGS+=-s
 
 # Uncomment for FreeBSD:
 #CC=cc
-#CFLAGS=-O2 -Wall -fomit-frame-pointer
-#LDFLAGS=-s
+#CFLAGS+=-O2 -Wall -fomit-frame-pointer
+#LDFLAGS+=-s
 
 # Uncomment for OpenBSD:
 #TREE_DEST=colortree
 #MAN=colortree.1
-#CFLAGS=-O2 -Wall -fomit-frame-pointer
-#LDFLAGS=-s
+#CFLAGS+=-O2 -Wall -fomit-frame-pointer
+#LDFLAGS+=-s
 
 # Uncomment for Solaris:
 #CC=cc
-#CFLAGS=-xO0 -v
-#LDFLAGS=
+#CFLAGS+=-xO0 -v
+#LDFLAGS+=
 #MANDIR=${prefix}/share/man
 
 # Uncomment for Cygwin:
-#CFLAGS=-O2 -Wall -fomit-frame-pointer
-#LDFLAGS=-s
+#CFLAGS+=-O2 -Wall -fomit-frame-pointer
+#LDFLAGS+=-s
 #TREE_DEST=tree.exe
 
 # Uncomment for OS X:
 # It is not allowed to install to /usr/bin on OS X any longer (SIP):
 #CC=cc
-#CFLAGS=-O2 -Wall -fomit-frame-pointer -no-cpp-precomp
-#LDFLAGS=
+#CFLAGS+=-O2 -Wall -fomit-frame-pointer -no-cpp-precomp
+#LDFLAGS+=
 #MANDIR=${PREFIX}/share/man
 
 # Uncomment for HP/UX:
 #prefix=/opt
 #CC=cc
 # manpage of mbsrtowcs() requires C99 and the two defines
-#CFLAGS=+w -D_XOPEN_SOURCE=500 -D_POSIX_C_SOURCE=200112 -AC99
-#LDFLAGS=
+#CFLAGS+=+w -D_XOPEN_SOURCE=500 -D_POSIX_C_SOURCE=200112 -AC99
+#LDFLAGS+=
 #MANDIR=${PREFIX}/share/man
 
 # Uncomment for OS/2:
-#CFLAGS=-02 -Wall -fomit-frame-pointer -Zomf -Zsmall-conv
-#LDFLAGS=-s -Zomf -Zsmall-conv
+#CFLAGS+=-02 -Wall -fomit-frame-pointer -Zomf -Zsmall-conv
+#LDFLAGS+=-s -Zomf -Zsmall-conv
 
 # Uncomment for HP NonStop:
 #prefix = /opt
 #CC=c89
-#CFLAGS=-Wextensions -WIEEE_float -g -Wnowarn=1506 -D_XOPEN_SOURCE_EXTENDED=1 \
+#CFLAGS+=-Wextensions -WIEEE_float -g -Wnowarn=1506 -D_XOPEN_SOURCE_EXTENDED=1 \
 #	 -Wallow_cplusplus_comments
-#LDFLAGS=
+#LDFLAGS+=
 
 # AIX
 #CC=cc_r -q64
 #LD=ld -d64
-#LDFLAGS=-lc
+#LDFLAGS+=-lc
 
 #------------------------------------------------------------

=== debian/changelog ===
tree (2.0.3-1) unstable; urgency=medium

  * [728e13f] New upstream version 2.0.3
  * [b54b81e] debian/copyright: redo in machine-readable format (DEP-5)
  * [0a01f34] debian/patches/manpage: refresh, fixing a typo
  * [fe36e7d] debian/control: declare RRR: no and Standards-Version: 4.6.1.0

 -- Florian Ernst <florian@debian.org>  Sun, 28 Aug 2022 08:57:47 +0200

## tree 2.0.4

=== debian/changelog ===
tree (2.0.4-1) unstable; urgency=medium

  * [97dab0a] New upstream version 2.0.4

 -- Florian Ernst <florian@debian.org>  Sat, 10 Sep 2022 12:50:48 +0200

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: tree
 Section: utils
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Florian Ernst <florian@debian.org>
+Maintainer: Florian Ernst <florian@debian.org>
 Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.16.1~)
-Standards-Version: 4.6.0.1
+Standards-Version: 4.6.1.0
+Rules-Requires-Root: no
 Homepage: http://mama.indstate.edu/users/ice/tree/
 Vcs-Git: https://salsa.debian.org/debian/tree-packaging.git
 Vcs-Browser: https://salsa.debian.org/debian/tree-packaging

## tree 2.1.0

=== Makefile ===
--- 
+++ 
@@ -21,7 +21,7 @@
 CC=gcc
 INSTALL=install
 
-VERSION=2.0.3
+VERSION=2.1.0
 TREE_DEST=tree
 DESTDIR=${PREFIX}/bin
 MAN=tree.1
@@ -32,8 +32,8 @@
 # Uncomment options below for your particular OS:
 
 # Linux defaults:
-CFLAGS=-ggdb -pedantic -Wall -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
-#CFLAGS+=-O3 -pedantic -Wall -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
+#CFLAGS+=-ggdb -std=c11 -pedantic -Wall -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
+CFLAGS+=-O3 -std=c11 -pedantic -Wall -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
 #LDFLAGS+=-s
 
 # Uncomment for FreeBSD:

=== debian/changelog ===
tree (2.1.0-1) unstable; urgency=medium

  * [1c70da4] New upstream version 2.1.0
    - adds --hintro and --houtro options to replace the normal HTML intro and
      outros with user defined ones (Closes: #865867, #939644)
    - adds a --fflinks option recognizing symbolic links (Closes: #934520)
    - fixes long option processing of --timefmt= (Closes: #1014621)
    - Thanks to Steve Baker for explicitly fixing these!
  * [8f7f775] upstream removed the (very outdated) French version of the
    manpage
  * [76f2c3e] debian/patches/speling: added to fix some upstream misspellings
  * [e96ff99] debian/rules: update CFLAGS and drop override_dh_auto_clean
  * [abdac86] debian/control: Remove unnecessary Build-Depends constraints
  * [2ae5ffe] Standards-Version: 4.6.2 (no changes required)

 -- Florian Ernst <florian@debian.org>  Thu, 29 Dec 2022 16:08:49 +0100

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: utils
 Priority: optional
 Maintainer: Florian Ernst <florian@debian.org>
-Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.16.1~)
-Standards-Version: 4.6.1.0
+Build-Depends: debhelper-compat (= 13)
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: http://mama.indstate.edu/users/ice/tree/
 Vcs-Git: https://salsa.debian.org/debian/tree-packaging.git

=== debian/watch ===
version=4
http://mama.indstate.edu/users/ice/@PACKAGE@/src/ \
    @PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@

## tree 2.1.1

=== debian/changelog ===
tree (2.1.1-2ubuntu3.25.04.2) plucky; urgency=medium

  * Fix segmentation fault in XML output (LP: #2113790)
    - d/p/0001-tree-list-call-printinfo-on-error-cases-too.patch:
      replace previous patch that caused segfault in XML output,
      thanks to Simon Chopin

 -- Nadzeya Hutsko <nadzeya.hutsko@canonical.com>  Mon, 27 Oct 2025 14:23:15 +0100

tree (2.1.1-2ubuntu3.25.04.1) plucky; urgency=medium

  * Fix XML/JSON output on empty directories (LP: #2113790)
    - d/p/0001-tree-list-call-printinfo-on-error-cases-too.patch:
      call printinfo on error cases too, thanks to Simon Chopin
    - d/t/clitest.md: update expected output for new patch

 -- Nadzeya Hutsko <nadzeya.hutsko@canonical.com>  Tue, 21 Oct 2025 09:11:27 +0200

tree (2.1.1-2ubuntu3) noble; urgency=medium

  * Add 'introduce-a-test-framework' patch to 'clitest.md' (LP: #2060550)

 -- Mate Kukri <mate.kukri@canonical.com>  Mon, 08 Apr 2024 13:59:53 +0100

tree (2.1.1-2ubuntu2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 17:20:33 +0000

tree (2.1.1-2ubuntu1) noble; urgency=medium

  * debian/patches/introduce-a-test-framework added from upstream
    GitLab MR 19 to add minimal compile time unit test as needed
    by LP #2056099

 -- Alexandre Esse <alexandre.esse@canonical.com>  Fri, 29 Mar 2024 14:37:33 +0000

tree (2.1.1-2) unstable; urgency=medium

  * [41019d9] d/{control,copyright,watch}: update upstream homepage
  * [c41b7e5] d/salsa-ci.yml: add to enable Salsa pipeline
  * [4b41853] debian/tests/: add some autopkgtest using clitest

 -- Florian Ernst <florian@debian.org>  Tue, 12 Dec 2023 17:06:39 +0100

tree (2.1.1-1) unstable; urgency=medium

  * [b6321d2] New upstream version 2.1.1
  * [bb85e91] drop patches applied upstream and refresh remaining
  * [d1974c3] debian/copyright: update years

 -- Florian Ernst <florian@debian.org>  Mon, 26 Jun 2023 18:09:47 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: tree
 Section: utils
 Priority: optional
-Maintainer: Florian Ernst <florian@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Florian Ernst <florian@debian.org>
 Build-Depends: debhelper-compat (= 13)
 Standards-Version: 4.6.2
 Rules-Requires-Root: no
-Homepage: http://mama.indstate.edu/users/ice/tree/
+Homepage: http://oldmanprogrammer.net/source.php?dir=projects/tree
 Vcs-Git: https://salsa.debian.org/debian/tree-packaging.git
 Vcs-Browser: https://salsa.debian.org/debian/tree-packaging

=== debian/tests/control ===
Test-Command: clitest --pre-flight 'export LC_ALL=C' debian/tests/clitest.md
Depends: @, clitest

## tree 2.1.3

=== debian/changelog ===
tree (2.1.3-1) unstable; urgency=medium

  * [72f04ce] New upstream version 2.1.3
  * [c22aae1] Revert "d/tests/: temporarily disable fromfile test (to be
    clarified with upstream)", as the new release addresses this
  * [9d7d635] d/patches/: refresh for new upstream version

 -- Florian Ernst <florian@debian.org>  Sat, 13 Jul 2024 14:51:48 +0200

tree (2.1.2-1) unstable; urgency=medium

  * [2b83084] New upstream version 2.1.2
  * [67253e7] d/copyright: update year and upstream email address
  * [ced472d] d/patches/, d/tests/: refresh for new upstream version
  * [37e4716] d/tests/: temporarily disable fromfile test (to be clarified
    with upstream)
  * [1d0ac55] d/rules: override_dh_auto_clean to clean the resulting binary
    (cf. e96ff99) (Closes: #1046930)
  * [9fc2c0f] d/control: Standards-Version: 4.7.0 (no changes required)

 -- Florian Ernst <florian@debian.org>  Thu, 04 Jul 2024 19:40:07 +0200

## tree 2.2.1

=== debian/changelog ===
tree (2.2.1-4) unstable; urgency=medium

  * [078ede2] d/patches/: enable updated patch to fix JSON and XML output
    broken if path invalid. Also add test cases for nonexistent directories.
    Thanks to Simon Chopin <schopin@ubuntu.com> for the patch and Nadzeya
    Hutsko <nadzya.info@gmail.com> for the pointer.
    (Closes: #1118451) (LP: #2113790)

 -- Florian Ernst <florian@debian.org>  Sun, 02 Nov 2025 14:19:53 +0100

tree (2.2.1-3) unstable; urgency=medium

  * [54d89f5] d/patches/: update patch to fix JSON and XML output broken if
    path invalid. 
    But actually disable it for now as it seems further clarification is
    required, cf. LP#2113790.

 -- Florian Ernst <florian@debian.org>  Sat, 25 Oct 2025 17:28:54 +0200

tree (2.2.1-2) unstable; urgency=medium

  * [7013425] d/patches/: add patch to fix JSON and XML output broken if path
    invalid. Thanks to Simon Chopin <schopin@ubuntu.com> for the patch and
    Nadzeya Hutsko <nadzya.info@gmail.com> for the pointer.
    (Closes: #1118451) (LP: #2113790)
  * [00c9201] d/control: drop now-obsolete Rules-Requires-Root
  * [c76c8fb] d/control: Standards-Version: 4.7.2 (no changes required)

 -- Florian Ernst <florian@debian.org>  Sat, 25 Oct 2025 15:29:04 +0200

tree (2.2.1-1) unstable; urgency=medium

  * [70f7a56] New upstream version 2.2.1
  * [cac2952] d/patches/manpage: refresh for new upstream release
  * [b359dc8] d/tests/clitest.md: adjust for new upstream release

 -- Florian Ernst <florian@debian.org>  Tue, 26 Nov 2024 21:06:37 +0100

tree (2.2.0-1) unstable; urgency=medium

  * [8e8b77c] d/watch: http -> https
  * [d68384d] New upstream version 2.2.0
  * [0a78ae8] d/patches/manpage: refresh for new upstream release

 -- Florian Ernst <florian@debian.org>  Mon, 25 Nov 2024 14:37:46 +0100

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,9 @@
 Source: tree
 Section: utils
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Florian Ernst <florian@debian.org>
+Maintainer: Florian Ernst <florian@debian.org>
 Build-Depends: debhelper-compat (= 13)
-Standards-Version: 4.6.2
-Rules-Requires-Root: no
+Standards-Version: 4.7.2
 Homepage: http://oldmanprogrammer.net/source.php?dir=projects/tree
 Vcs-Git: https://salsa.debian.org/debian/tree-packaging.git
 Vcs-Browser: https://salsa.debian.org/debian/tree-packaging

## tree 2.3.1

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # $Copyright: $
-# Copyright (c) 1996 - 2022 by Steve Baker
+# Copyright (c) 1996 - 2026 by Steve Baker (steve.baker.llc@gmail.com)
 # All Rights reserved
 #
 # This program is free software; you can redistribute it and/or modify
@@ -18,33 +18,40 @@
 
 PREFIX=/usr/local
 
-CC=gcc
-INSTALL=install
 
-VERSION=2.1.0
+CC ?= gcc
+INSTALL ?= install
+
+VERSION=2.3.1
 TREE_DEST=tree
 DESTDIR=${PREFIX}/bin
 MAN=tree.1
 # Probably needs to be ${PREFIX}/share/man for most systems now
 MANDIR=${PREFIX}/man
-OBJS=tree.o list.o hash.o color.o file.o filter.o info.o unix.o xml.o json.o html.o strverscmp.o
+OBJS=color.o file.o filter.o hash.o html.o info.o json.o list.o tree.o unix.o \
+     util.o xml.o strverscmp.o
 
 # Uncomment options below for your particular OS:
 
 # Linux defaults:
-#CFLAGS+=-ggdb -std=c11 -pedantic -Wall -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
-CFLAGS+=-O3 -std=c11 -pedantic -Wall -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
-#LDFLAGS+=-s
+LDFLAGS?=-s
+#CFLAGS?=-ggdb
+CFLAGS?=-O3
+CFLAGS+=-std=c11 -Wpedantic -Wall -Wextra -Wstrict-prototypes -Wshadow -Wconversion
+# _LARGEFILE64_SOURCE may be considered obsolete
+CPPFLAGS+=-DLARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64
 
 # Uncomment for FreeBSD:
 #CC=cc
-#CFLAGS+=-O2 -Wall -fomit-frame-pointer
+#CFLAGS?=-O2
+#CFLAGS+=-Wall -fomit-frame-pointer
 #LDFLAGS+=-s
 
 # Uncomment for OpenBSD:
 #TREE_DEST=colortree
 #MAN=colortree.1
-#CFLAGS+=-O2 -Wall -fomit-frame-pointer
+#CFLAGS?=-O2
+#CFLAGS+=-Wall -fomit-frame-pointer
 #LDFLAGS+=-s
 
 # Uncomment for Solaris:
@@ -54,14 +61,16 @@
 #MANDIR=${prefix}/share/man
 
 # Uncomment for Cygwin:
-#CFLAGS+=-O2 -Wall -fomit-frame-pointer
+#CFLAGS?=-O2
+#CFLAGS+=-Wall -fomit-frame-pointer
 #LDFLAGS+=-s
 #TREE_DEST=tree.exe
 
-# Uncomment for OS X:
-# It is not allowed to install to /usr/bin on OS X any longer (SIP):
-#CC=cc
-#CFLAGS+=-O2 -Wall -fomit-frame-pointer -no-cpp-precomp
+# Uncomment for MacOS:
+# It is not allowed to install to /usr/bin on MacOS any longer (SIP):
+#CC = cc
+#CFLAGS?=-O2
+#CFLAGS+=-Wall -fomit-frame-pointer -no-cpp-precomp
 #LDFLAGS+=
 #MANDIR=${PREFIX}/share/man
 
@@ -69,12 +78,14 @@
 #prefix=/opt
 #CC=cc
 # manpage of mbsrtowcs() requires C99 and the two defines
-#CFLAGS+=+w -D_XOPEN_SOURCE=500 -D_POSIX_C_SOURCE=200112 -AC99
+#CFLAGS+=+w -AC99
+#CPPFLAGS+=-D_XOPEN_SOURCE=500 -D_POSIX_C_SOURCE=200112 
 #LDFLAGS+=
 #MANDIR=${PREFIX}/share/man
 
 # Uncomment for OS/2:
-#CFLAGS+=-02 -Wall -fomit-frame-pointer -Zomf -Zsmall-conv
+#CFLAGS?=-O2
+#CFLAGS+=-Wall -fomit-frame-pointer -Zomf -Zsmall-conv
 #LDFLAGS+=-s -Zomf -Zsmall-conv
 
 # Uncomment for HP NonStop:
@@ -89,6 +100,13 @@
 #LD=ld -d64
 #LDFLAGS+=-lc
 
+# Android NDK
+#CC=aarch64-linux-android26-clang # Need >= 26
+#CFLAGS?=-O2    # Or:
+#CFLAGS?=-ggdb
+#CFLAGS+=-std=c89 -pedantic -Wall -Wno-error=int-conversion
+#CPPFLAGS+=-D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
+
 #------------------------------------------------------------
 
 all:	tree
@@ -97,7 +115,7 @@
 	$(CC) $(LDFLAGS) -o $(TREE_DEST) $(OBJS)
 
 $(OBJS): %.o:	%.c tree.h
-	$(CC) $(CFLAGS) -c -o $@ $<
+	$(CC) $(CFLAGS) $(CPPFLAGS) -c -o $@ $<
 
 clean:
 	rm -f $(TREE_DEST) *.o *~

=== debian/changelog ===
tree (2.3.1-1) unstable; urgency=medium

  * [ec97d79] New upstream version 2.3.0
  * [ce962b3] New upstream version 2.3.1
  * [f69c365] d/patches: drop patch applied upstream and refresh remaining
  * [0e1630a] d/control: drop redundant "Priority: optional"
  * [0ce96d9] d/copyright: update years
  * [bb45320] d/tests/clitest.md: adjust for new upstream release
  * [e92de70] d/control: Standards-Version: 4.7.3

 -- Florian Ernst <florian@debian.org>  Tue, 03 Feb 2026 18:59:03 +0100

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,8 @@
 Source: tree
 Section: utils
-Priority: optional
 Maintainer: Florian Ernst <florian@debian.org>
 Build-Depends: debhelper-compat (= 13)
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: http://oldmanprogrammer.net/source.php?dir=projects/tree
 Vcs-Git: https://salsa.debian.org/debian/tree-packaging.git
 Vcs-Browser: https://salsa.debian.org/debian/tree-packaging
